routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
//Home Login-Register
Route::get('/login','HomeController@login')->name('login');
Route::post('/post_login','HomeController@post_login')->name('post_login');
Route::get('/register','HomeController@register')->name('register');
Route::get('/logout','HomeController@logout')->name('logout');
Route::post('/post_register','HomeController@post_register')->name('post_register');

//Reset Password
Route::get('/get_password','ForgotPasswordController@getFormResetPassword')->name('reset_password');
Route::post('/get_password','ForgotPasswordController@sendCodeResetPassword');
Route::get('/password/reset','ForgotPasswordController@resetPassword')->name('send_link');
Route::post('/password/reset','ForgotPasswordController@saveResetPassword');

//Home
Route::get('/','HomeController@index')->name('index');
Route::get('/shop/{id}-{slug}','HomeController@view')->name('view');
Route::get('/shop/product_detail/{id}-{slug}','HomeController@product_detail')->name('product_detail');
Route::get('/about','HomeController@about')->name('about');
Route::get('/service','HomeController@service')->name('service');
Route::get('/shop','HomeController@shop')->name('shop');
Route::get('/contact','HomeController@contact')->name('contact');
Route::get('/blog','HomeController@blog')->name('blog');
Route::get('/blog_view/{slug}','HomeController@blog_view')->name('blog_view');
Route::get('/single_blog/{id}','HomeController@single_blog')->name('single_blog');

Route::post('/subcriber','HomeController@sub')->name('sub');
Route::post('/contact/Con','HomeController@con')->name('con');

Route::group(['middleware'=>'client'],function(){
    //Favorite
    Route::get('/favorite','FavController@index')->name('fav.index');
    Route::get('/favorite/add-{id}','FavController@create')->name('fav.add');
    Route::get('/favorite/del-{id}','FavController@del')->name('fav.del');
    Route::get('/favorite/destroy','FavController@destroy')->name('fav.destroy');
    
    //Cart
    Route::get('/shopping_cart','HomeController@shopping_cart')->name('shopping_cart');
    Route::group(['prefix' => 'cart'], function () {
        Route::get('view','CartController@view')->name('cart.view');
        Route::post('add','CartController@add')->name('cart.add');
        Route::get('remove/{id}','CartController@remove')->name('cart.remove');
        Route::post('update','CartController@update')->name('cart.update');
        Route::get('clear','CartController@clear')->name('cart.clear');
    });
    Route::get('/checkout','HomeController@checkout')->name('checkout');
    Route::post('/submit','CheckoutController@submit')->name('submit');
    Route::get('/checkout_success','HomeController@checkout_success')->name('checkout_success');
    Route::post('/coupon','CartController@coupon')->name('coupon');

    //Profile-Edit
    Route::get('/profile','HomeController@profile')->name('profile');
    Route::post('/profile_edit','HomeController@profile_edit')->name('profile_edit');
    
    //Rating
    Route::post('/Rating/add','RatingCommentController@addRating')->name('rating.add');
    Route::post('/Comment/add','RatingCommentController@addComment')->name('comment.add');
});

//Admin-login-Register
Route::get('/admin/login','admin\AdminController@login')->name('admin.login');
Route::post('/admin/post_login','admin\AdminController@post_login')->name('admin.post_login');
Route::get('/admin/register','admin\AdminController@register')->name('admin.register');
Route::get('/admin/logout','admin\AdminController@logout')->name('admin.logout');
Route::post('/admin/post_register','admin\AdminController@post_register')->name('admin.post_register');
Route::get('/admin/error','admin\AdminController@error')->name('admin.error');

//Admin
Route::group(['prefix'=>'admin','middleware'=>'auth','as'=>'admin.'],function(){
    Route::get('/','admin\AdminController@index')->name('index');
    Route::get('/config','admin\ConfigWebController@index')->name('config.index');
    Route::get('/config/create','admin\ConfigWebController@create')->name('config.create');
    Route::post('/config/store','admin\ConfigWebController@store')->name('config.store');
    Route::get('/config/edit/{id}','admin\ConfigWebController@edit')->name('config.edit');
    Route::put('/config/update/{id}','admin\ConfigWebController@update')->name('config.update');
    Route::get('/admin/profile', 'admin\AdminController@profile')->name('info');
    Route::put('/admin/profile/edit/{id}','admin\AdminController@post_profile')->name('profile');
    Route::put('/admin/profile/edit-avatar/{id}','admin\AdminController@post_avatar')->name('avatar');
    Route::get('/admin/profile/edit-change_password/{id}','admin\AdminController@form_password')->name('change_pass');
    Route::put('/admin/profile/password/{id}','admin\AdminController@post_password')->name('post_password');
    Route::resource('/Category','admin\CategoryController');
    Route::resource('/Product','admin\ProductController');
    Route::resource('/Brand','admin\BrandController');
    Route::resource('/Color','admin\ColorController');
    Route::resource('/Role','admin\RoleController');
    Route::resource('/User','admin\UserController');
    Route::resource('/Blog','admin\BlogController');
    Route::resource('/Comment','admin\CommentController');
    Route::resource('/Payment','admin\PaymentController');
    Route::resource('/Shipping','admin\ShippingController');
    Route::resource('/Client','admin\ClientController');
    Route::resource('/Banner','admin\BannerController');
    Route::resource('/Subcriber','admin\SubcriberController');
    Route::resource('/Contact','admin\ContactController');
    Route::resource('/Quote','admin\QuoteController');
    Route::resource('/Order','admin\OrderController');
});

app/Models/Brand.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Brand extends Model
{
    protected $fillable = ['name', 'slug','image'];

    public function product(){
        return $this->hasMany(Product::class,'brand_id','id');
    }

    public function scopeSearch($query){
        if(request()->key){
            $keyword = request()->key;
            $query->where('name','LIKE','%'.$keyword.'%');
        }
        return $query;
    }
    public function scopeAdd(){
        $model = $this->create([
            'name'=>request()->name,
            'slug'=>\Str::slug(request()->name),
            'image'=>request()->image,
        ]);
        if($model){
            return $noti = ['type'=>'success','message'=>'Successfully added!'];
        }else{
            return $noti = ['type'=>'error','message'=>'New addition failed!'];
        }
    }
    public function scopeModify($query,$id){
        $brand =$this->find($id);
        if(request()->image){
            request()->merge(['image'=>request()->image]);
        }
        request()->merge(['slug'=>\Str::slug(request()->name),]);
        $model = $brand->update(request()->except('_token','_method','id'));
        if($model){
            return $noti = ['type'=>'success','message'=>'Successfully fixed!'];
        }else{
            return $noti = ['type'=>'error','message'=>'Fix failed!'];
        }
    }
    public function scopeRemove($query,$id){
        $pro = $this->find($id);
        $count = $pro->product()->count();
        if($count>0){
            return $noti = ['type'=>'error','message'=>'Đang có '.$count.' sản phẩm!'];
        }else{
            $pro->delete();
            return $noti = ['type'=>'success','message'=>'Deleted successfully!'];
        }
    }
}

app/Http/Controllers/admin/BrandController.php
<?php

namespace App\Http\Controllers\admin;

use App\Http\Controllers\Controller;
use App\Models\Brand;
use Illuminate\Http\Request;
use App\Http\Requests\brand\AddBrandRequest;
use App\Http\Requests\brand\EditBrandRequest;

class BrandController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $brands = Brand::Search()->paginate(3);
        return view('admin.brand.index',compact('brands'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.brand.addBrand');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(AddBrandRequest $request)
    {
        $ms = Brand::add();
        return redirect()->route('admin.Brand.index')->with($ms['type'],$ms['message']);
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Brand  $brand
     * @return \Illuminate\Http\Response
     */
    public function show(Brand $brand)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Brand  $brand
     * @return \Illuminate\Http\Response
     */
    public function edit($id, Brand $brand)
    {
        $brand = Brand::find($id);
        return view('admin.brand.editBrand',compact('brand'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Brand  $brand
     * @return \Illuminate\Http\Response
     */
    public function update($id, EditBrandRequest $request)
    {
        $ms = Brand::modify($id);
        return redirect()->route('admin.Brand.index')->with($ms['type'],$ms['message']);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Brand  $brand
     * @return \Illuminate\Http\Response
     */
    public function destroy($id, Brand $brand)
    {
        $ms = Brand::remove($id);
        return redirect()->back()->with($ms['type'],$ms['message']);
    }
}

resources/views/admin/brand/addBrand.blade.php
@extends('layout.admin')
@section('title','ADD BRAND')
@section('bar_form')
<a href="{{route('admin.Brand.index')}}" style="margin:10px" title="Về danh sách" class="btn btn-info btn-sm ml-1"><i class="fa fa-undo"></i> Back</a>
@stop()
@section('main')


<div class="panel panel-default">
    <div class="panel-body">

        <form action="{{route('admin.Brand.store')}}" method="POST" role="form" enctype="multipart/form-data">
            @csrf
            <div class="form-group">
                <label for="">Name</label>
                <input type="text" class="form-control" name="name" placeholder="Name">
            </div>
            @error('name')
            <div class="alert alert-warning">
                <button type="button" class="close" data-dismiss="alert" aria-hidden="true">&times;</button>
                <strong>{{$message}}</strong>
            </div>
            @enderror

            <div class="form-group">
                <label for="">Image</label>
                <div class="input-group">
                    <input type="text" class="form-control" id="show_img" name="image">
                    <span class="input-group-btn">
                        <a class="btn btn-primary" data-toggle="modal" href='#modal-id'>Select</a>
                    </span>
                </div>
                <div class="form-group">
                    <img src="" id="show" width="100%" alt="">
                </div>
            </div>
            @error('image')
            <div class="alert alert-warning">
                <button type="button" class="close" data-dismiss="alert" aria-hidden="true">&times;</button>
                <strong>{{$message}}</strong>
            </div>
            @enderror

            <button type="submit" class="btn btn-primary">Add Brand</button>
        </form>

    </div>
</div>

<div class="modal fade" id="modal-id">
    <div class="modal-dialog" style="width:90%">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                <h4 class="modal-title">Ảnh</h4>
            </div>
            <div class="modal-body">
                <iframe
                    src="{{url('public/filemanager')}}/dialog.php?akey=JDmgWEZBvxs9fYw6jRK7qsB5QJnafF4ig39kw4ygs&field_id=show_img"
                    style="height:500px; width:100%" frameborder="0"></iframe>
            </div>

        </div>
    </div>
</div>


@stop

@section('js')

<script src="{{url('public/tinymce')}}/config.js"></script>
<script>
$('#modal-id').on('hide.bs.modal', function() {
    var show = $('#show_img').val();
    $('#show').attr('src', show);
})
</script>

@stop

resources/views/admin/brand/editBrand.blade.php
@extends('layout.admin')
@section('title','EDIT BRAND')
@section('bar_form')
<a href="{{route('admin.Brand.index')}}" style="margin:10px" title="Về danh sách" class="btn btn-info btn-sm ml-1"><i class="fa fa-undo"></i> Back</a>
@stop()
@section('main')



<div class="panel panel-default">
    <div class="panel-body">
        <form action="{{route('admin.Brand.update',$brand->id)}}" method="POST" role="form"
            enctype="multipart/form-data">
            <legend>Form title</legend>
            @csrf @method('PUT')
            <input type="hidden" class="form-control" name="id" value="{{$brand->id}}">
            <div class="form-group">
                <label for="">Name</label>
                <input type="text" class="form-control" name="name" value="{{$brand->name}}">
            </div>
            @error('name')
            <div class="alert alert-warning">
                <button type="button" class="close" data-dismiss="alert" aria-hidden="true">&times;</button>
                <strong>{{$message}}</strong>
            </div>
            @enderror
            <div class="form-group">
                <label for="">Image</label>
                <div class="input-group">
                    <input type="text" class="form-control" id="show_img" name="image">
                    <span class="input-group-btn">
                        <a class="btn btn-primary" data-toggle="modal" href='#modal-id'>Select</a>
                    </span>
                </div>
                <div class="form-group">
                    <img src="{{$brand->image}}" id="show" width="100%" alt="">
                </div>
            </div>
            @error('image')
            <div class="alert alert-warning">
                <button type="button" class="close" data-dismiss="alert" aria-hidden="true">&times;</button>
                <strong>{{$message}}</strong>
            </div>
            @enderror


            <button type="submit" class="btn btn-primary">Edit Brand</button>
        </form>
    </div>
</div>

<div class="modal fade" id="modal-id">
    <div class="modal-dialog" style="width:90%">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                <h4 class="modal-title">Ảnh</h4>
            </div>
            <div class="modal-body">
                <iframe
                    src="{{url('public/filemanager')}}/dialog.php?akey=JDmgWEZBvxs9fYw6jRK7qsB5QJnafF4ig39kw4ygs&field_id=show_img"
                    style="height:500px; width:100%" frameborder="0">
                </iframe>
            </div>

        </div>
    </div>
</div>


@stop

@section('js')
<script>
$('#modal-id').on('hide.bs.modal', function() {
    var show = $('#show_img').val();
    $('#show').attr('src', show);
})
</script>
@stop

resources/views/admin/brand/index.blade.php
@extends('layout.admin')
@section('title','BRAND')
@section('bar_form')
<a href="{{route('admin.index')}}" style="margin:10px" title="Về danh sách" class="btn btn-info btn-sm ml-1"><i class="fa fa-undo"></i> Back</a>
@stop()
@section('main')

<div class="panel panel-default">
    <div class="panel-heading">
        <form action="{{route('admin.Brand.index')}}" method="GET" class="form-inline" role="form">
            <div class="form-group">
                <label class="sr-only" for="">label</label>
                <input class="form-control" name="key" value="{{request()->key}}">
            </div>

            <button type="submit" class="btn btn-primary">Find</button>

            <a class="btn btn-success" href="{{route('admin.Brand.create')}}">Add Brand</a>
        </form>
    </div>
    <div class="panel-body">
        <table class="table table-hover">
            <thead>
                <tr>
                    <th>Id</th>
                    <th>Name</th>
                    <th>image</th>
                    <th>Slug</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>
                @foreach($brands as $brand)
                <tr>
                    <td>{{$brand->id}}</td>
                    <td>{{$brand->name}}</td>
                    <td><img src="{{$brand->image}}" width="50px" height="50px" alt="">
                    </td>
                    <td>{{$brand->slug}}</td>
                    <td>

                        <form action="{{route('admin.Brand.destroy',$brand->id)}}" method="POST" role="form">
                            @csrf @method('DELETE')
                            <a href="{{route('admin.Brand.edit',$brand->id)}}" class="btn btn-primary btn-xs">Edit</a>
                            <button type="submit" class="btn btn-danger btn-xs">Delete</button>
                        </form>


                    </td>
                </tr>
                @endforeach
            </tbody>
        </table>
        <div class="text-center">{{$brands->links()}}</div>
    </div>
</div>
@stop()

@section('js')

@if(Session::has('success'))
	<script type="text/javascript">
		toastr.success("{{Session::get('success')}}")
	</script>
@endif

@if(Session::has('error'))
	<script type="text/javascript">
		toastr.error("{{Session::get('error')}}")
	</script>
@endif

@stop()